package ru.ulstu.fc.project.controller;

import org.springframework.security.access.annotation.Secured;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import ru.ulstu.fc.project.model.Project;
import ru.ulstu.fc.project.model.ProjectForm;
import ru.ulstu.fc.project.service.ProjectService;
import ru.ulstu.fc.user.model.UserRoleConstants;

import java.util.List;

@RestController
@RequestMapping("projectRest")
@Secured({UserRoleConstants.ADMIN})
public class ProjectRestController {
    private final ProjectService projectService;

    public ProjectRestController(ProjectService projectService) {
        this.projectService = projectService;
    }

    @GetMapping("list")
    public List<Project> getProjects() {
        return projectService.getCurrentUserProjects();
    }

    @PostMapping("save")
    public Project save(Project project) {
        return projectService.save(project);
    }

    @DeleteMapping("delete")
    public String delete(ProjectForm projectForm) {
        projectService.delete(projectForm);
        return "redirect:/list";
    }
}
